summaryrefslogtreecommitdiff
path: root/oh-my-zsh/plugins/vi-mode
diff options
context:
space:
mode:
Diffstat (limited to 'oh-my-zsh/plugins/vi-mode')
-rw-r--r--oh-my-zsh/plugins/vi-mode/README.md132
-rw-r--r--oh-my-zsh/plugins/vi-mode/vi-mode.plugin.zsh145
2 files changed, 277 insertions, 0 deletions
diff --git a/oh-my-zsh/plugins/vi-mode/README.md b/oh-my-zsh/plugins/vi-mode/README.md
new file mode 100644
index 0000000..476666b
--- /dev/null
+++ b/oh-my-zsh/plugins/vi-mode/README.md
@@ -0,0 +1,132 @@
+# vi-mode plugin
+
+This plugin increase `vi-like` zsh functionality.
+
+To use it, add `vi-mode` to the plugins array in your zshrc file:
+
+```zsh
+plugins=(... vi-mode)
+```
+
+## Settings
+
+- `VI_MODE_RESET_PROMPT_ON_MODE_CHANGE`: controls whether the prompt is redrawn when
+ switching to a different input mode. If this is unset, the mode indicator will not
+ be updated when changing to a different mode.
+ Set it to `true` to enable it. For example:
+
+ ```zsh
+ VI_MODE_RESET_PROMPT_ON_MODE_CHANGE=true
+ ```
+
+ The default value is unset, unless `vi_mode_prompt_info` is used, in which case it'll
+ automatically be set to `true`.
+
+- `VI_MODE_SET_CURSOR`: controls whether the cursor style is changed when switching
+ to a different input mode. Set it to `true` to enable it (default: unset):
+
+ ```zsh
+ VI_MODE_SET_CURSOR=true
+ ```
+
+- `MODE_INDICATOR`: controls the string displayed when the shell is in normal mode.
+ See [Mode indicators](#mode-indicators) for details.
+
+- `INSERT_MODE_INDICATOR`: controls the string displayed when the shell is in insert mode.
+ See [Mode indicators](#mode-indicators) for details.
+
+## Mode indicators
+
+*Normal mode* is indicated with a red `<<<` mark at the right prompt, when it
+hasn't been defined by theme, *Insert mode* is not displayed by default.
+
+You can change these indicators by setting the `MODE_INDICATOR` (*Normal mode*) and
+`INSERT_MODE_INDICATORS` (*Insert mode*) variables.
+This settings support Prompt Expansion sequences. For example:
+
+```zsh
+MODE_INDICATOR="%F{white}+%f"
+INSERT_MODE_INDICATOR="%F{yellow}+%f"
+```
+
+You can also use the `vi_mode_prompt_info` function in your prompt, which will display
+this mode indicator.
+
+## Key bindings
+
+Use `ESC` or `CTRL-[` to enter `Normal mode`.
+
+NOTE: some of these key bindings are set by zsh by default when using a vi-mode keymap.
+
+### History
+
+- `ctrl-p` : Previous command in history
+- `ctrl-n` : Next command in history
+- `/` : Search backward in history
+- `n` : Repeat the last `/`
+
+### Vim edition
+
+- `vv` : Edit current command line in Vim
+
+NOTE: this used to be bound to `v`. That is now the default (`visual-mode`).
+
+### Movement
+
+- `$` : To the end of the line
+- `^` : To the first non-blank character of the line
+- `0` : To the first character of the line
+- `w` : [count] words forward
+- `W` : [count] WORDS forward
+- `e` : Forward to the end of word [count] inclusive
+- `E` : Forward to the end of WORD [count] inclusive
+- `b` : [count] words backward
+- `B` : [count] WORDS backward
+- `t{char}` : Till before [count]'th occurrence of {char} to the right
+- `T{char}` : Till before [count]'th occurrence of {char} to the left
+- `f{char}` : To [count]'th occurrence of {char} to the right
+- `F{char}` : To [count]'th occurrence of {char} to the left
+- `;` : Repeat latest f, t, F or T [count] times
+- `,` : Repeat latest f, t, F or T in opposite direction
+
+### Insertion
+
+- `i` : Insert text before the cursor
+- `I` : Insert text before the first character in the line
+- `a` : Append text after the cursor
+- `A` : Append text at the end of the line
+- `o` : Insert new command line below the current one
+- `O` : Insert new command line above the current one
+
+### Delete and Insert
+
+- `ctrl-h` : While in *Insert mode*: delete character before the cursor
+- `ctrl-w` : While in *Insert mode*: delete word before the cursor
+- `d{motion}` : Delete text that {motion} moves over
+- `dd` : Delete line
+- `D` : Delete characters under the cursor until the end of the line
+- `c{motion}` : Delete {motion} text and start insert
+- `cc` : Delete line and start insert
+- `C` : Delete to the end of the line and start insert
+- `r{char}` : Replace the character under the cursor with {char}
+- `R` : Enter replace mode: Each character replaces existing one
+- `x` : Delete `count` characters under and after the cursor
+- `X` : Delete `count` characters before the cursor
+
+## Known issues
+
+### Low `$KEYTIMEOUT`
+
+A low `$KEYTIMEOUT` value (< 15) means that key bindings that need multiple characters,
+like `vv`, will be very difficult to trigger. `$KEYTIMEOUT` controls the number of
+milliseconds that must pass before a key press is read and the appropriate key binding
+is triggered. For multi-character key bindings, the key presses need to happen before
+the timeout is reached, so on low timeouts the key press happens too slow, and therefore
+another key binding is triggered.
+
+We recommend either setting `$KEYTIMEOUT` to a higher value, or remapping the key bindings
+that you want to trigger to a keyboard sequence. For example:
+
+```zsh
+bindkey -M vicmd 'V' edit-command-line # this remaps `vv` to `V` (but overrides `visual-mode`)
+```
diff --git a/oh-my-zsh/plugins/vi-mode/vi-mode.plugin.zsh b/oh-my-zsh/plugins/vi-mode/vi-mode.plugin.zsh
new file mode 100644
index 0000000..149d6bb
--- /dev/null
+++ b/oh-my-zsh/plugins/vi-mode/vi-mode.plugin.zsh
@@ -0,0 +1,145 @@
+# Control whether to force a redraw on each mode change.
+#
+# Resetting the prompt on every mode change can cause lag when switching modes.
+# This is especially true if the prompt does things like checking git status.
+#
+# Set to "true" to force the prompt to reset on each mode change.
+# Unset or set to any other value to do the opposite.
+#
+# The default is not to reset, unless we're showing the mode in RPS1.
+typeset -g VI_MODE_RESET_PROMPT_ON_MODE_CHANGE
+# Control whether to change the cursor style on mode change.
+#
+# Set to "true" to change the cursor on each mode change.
+# Unset or set to any other value to do the opposite.
+typeset -g VI_MODE_SET_CURSOR
+
+typeset -g VI_KEYMAP=main
+
+function _vi-mode-set-cursor-shape-for-keymap() {
+ [[ "$VI_MODE_SET_CURSOR" = true ]] || return
+
+ # https://vt100.net/docs/vt510-rm/DECSCUSR
+ local _shape=0
+ case "${1:-${VI_KEYMAP:-main}}" in
+ main) _shape=6 ;; # vi insert: line
+ viins) _shape=6 ;; # vi insert: line
+ isearch) _shape=6 ;; # inc search: line
+ command) _shape=6 ;; # read a command name
+ vicmd) _shape=2 ;; # vi cmd: block
+ visual) _shape=2 ;; # vi visual mode: block
+ viopp) _shape=0 ;; # vi operation pending: blinking block
+ *) _shape=0 ;;
+ esac
+ printf $'\e[%d q' "${_shape}"
+}
+
+# Updates editor information when the keymap changes.
+function zle-keymap-select() {
+ # update keymap variable for the prompt
+ typeset -g VI_KEYMAP=$KEYMAP
+
+ if [[ "${VI_MODE_RESET_PROMPT_ON_MODE_CHANGE:-}" = true ]]; then
+ zle reset-prompt
+ zle -R
+ fi
+ _vi-mode-set-cursor-shape-for-keymap "${VI_KEYMAP}"
+}
+zle -N zle-keymap-select
+
+# These "echoti" statements were originally set in lib/key-bindings.zsh
+# Not sure the best way to extend without overriding.
+function zle-line-init() {
+ local prev_vi_keymap
+ prev_vi_keymap="${VI_KEYMAP:-}"
+ typeset -g VI_KEYMAP=main
+ [[ "$prev_vi_keymap" != 'main' ]] && [[ "${VI_MODE_RESET_PROMPT_ON_MODE_CHANGE:-}" = true ]] && zle reset-prompt
+ (( ! ${+terminfo[smkx]} )) || echoti smkx
+ _vi-mode-set-cursor-shape-for-keymap "${VI_KEYMAP}"
+}
+zle -N zle-line-init
+
+function zle-line-finish() {
+ typeset -g VI_KEYMAP=main
+ (( ! ${+terminfo[rmkx]} )) || echoti rmkx
+ _vi-mode-set-cursor-shape-for-keymap default
+}
+zle -N zle-line-finish
+
+bindkey -v
+
+# allow vv to edit the command line (standard behaviour)
+autoload -Uz edit-command-line
+zle -N edit-command-line
+bindkey -M vicmd 'vv' edit-command-line
+
+# allow ctrl-p, ctrl-n for navigate history (standard behaviour)
+bindkey '^P' up-history
+bindkey '^N' down-history
+
+# allow ctrl-h, ctrl-w, ctrl-? for char and word deletion (standard behaviour)
+bindkey '^?' backward-delete-char
+bindkey '^h' backward-delete-char
+bindkey '^w' backward-kill-word
+
+# allow ctrl-r and ctrl-s to search the history
+bindkey '^r' history-incremental-search-backward
+bindkey '^s' history-incremental-search-forward
+
+# allow ctrl-a and ctrl-e to move to beginning/end of line
+bindkey '^a' beginning-of-line
+bindkey '^e' end-of-line
+
+function wrap_clipboard_widgets() {
+ # NB: Assume we are the first wrapper and that we only wrap native widgets
+ # See zsh-autosuggestions.zsh for a more generic and more robust wrapper
+ local verb="$1"
+ shift
+
+ local widget
+ local wrapped_name
+ for widget in "$@"; do
+ wrapped_name="_zsh-vi-${verb}-${widget}"
+ if [ "${verb}" = copy ]; then
+ eval "
+ function ${wrapped_name}() {
+ zle .${widget}
+ printf %s \"\${CUTBUFFER}\" | clipcopy 2>/dev/null || true
+ }
+ "
+ else
+ eval "
+ function ${wrapped_name}() {
+ CUTBUFFER=\"\$(clippaste 2>/dev/null || echo \$CUTBUFFER)\"
+ zle .${widget}
+ }
+ "
+ fi
+ zle -N "${widget}" "${wrapped_name}"
+ done
+}
+
+wrap_clipboard_widgets copy vi-yank vi-yank-eol vi-backward-kill-word vi-change-whole-line vi-delete vi-delete-char
+wrap_clipboard_widgets paste vi-put-{before,after}
+unfunction wrap_clipboard_widgets
+
+# if mode indicator wasn't setup by theme, define default, we'll leave INSERT_MODE_INDICATOR empty by default
+if [[ -z "$MODE_INDICATOR" ]]; then
+ MODE_INDICATOR='%B%F{red}<%b<<%f'
+fi
+
+function vi_mode_prompt_info() {
+ # If we're using the prompt to display mode info, and we haven't explicitly
+ # disabled "reset prompt on mode change", then set it here.
+ #
+ # We do that here instead of the `if` statement below because the user may
+ # set RPS1/RPROMPT to something else in their custom config.
+ : "${VI_MODE_RESET_PROMPT_ON_MODE_CHANGE:=true}"
+
+ echo "${${VI_KEYMAP/vicmd/$MODE_INDICATOR}/(main|viins)/$INSERT_MODE_INDICATOR}"
+}
+
+# define right prompt, if it wasn't defined by a theme
+if [[ -z "$RPS1" && -z "$RPROMPT" ]]; then
+ RPS1='$(vi_mode_prompt_info)'
+fi